<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Scopes/Synopsis/Parser.html -->
<!-- this view was generated by Scope -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis::Parser</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Scope">
<div class="navigation">
<span class="normal"><a href="../global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
<!-- this part was generated by Heading -->
<div class="class-module">namespace <a href="../Synopsis.html" >Synopsis</a>
</div><div class="class-name">class Parser

</div><div class="links"><div class="file">File: <a href="../../File/Synopsis/Parser.hh.html" target="detail">../Synopsis/Parser.hh</a></div> <div class="xref"><a href="../../XRef/xref18.html#Synopsis_mParser" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line29" ><img src="../../src-c++.png" alt="source code"/></a></div></div>   <div class="doc"><p>C++ Parser</p>
<p>This parser is a LL(k) parser with ad hoc rules such as
backtracking.</p>
<p>&lt;name&gt;() is the grammer rule for a non-terminal &lt;name&gt;.
opt_&lt;name&gt;() is the grammer rule for an optional non-terminal &lt;name&gt;.
is_&lt;name&gt;() looks ahead and returns true if the next symbol is &lt;name&gt;.</p>
</div>
<!-- this part was generated by Summary -->
<div class="summary">
<div class="heading">Public Classes Summary:</div>
<div class="item"><div class="synopsis">class <a href="Parser/Error.html" >Error</a></div> <div class="xref"><a href="../../XRef/xref18.html#Synopsis_mParser_mError" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line37" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Error is used to cache parse errors encountered during the execution
of the parse method.</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Typedefs Summary:</div>
<div class="item"><div class="synopsis">std::vector&lt;<a href="Parser/Error.html" >Error</a>*&gt; <a class="name" id="ErrorList">ErrorList</a></div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mErrorList" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line43" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Enums Summary:</div>
<div class="item"><div class="synopsis"><span class="name"><a href="Parser.html#RuleSet" >RuleSet</a></span> CXX, GCC, MSVC</div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mRuleSet" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line33" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>RuleSet defines non-standard optional rules that can be chosen at runtime.</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;<i>constructor</i> <a class="name" id="Parser_lLexer_A_cSymbolFactory_A_cint_r">Parser</a>(<a href="Lexer.html" >Lexer</a>&amp; <span class="variable">lexer</span>, <a href="SymbolFactory.html" >SymbolFactory</a>&amp; <span class="variable">symbols</span>, int <span class="variable">ruleset</span> = <span class="value">CXX | GCC</span>)  </div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mParser_lLexer_A_cSymbolFactory_A_cint_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line45" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<i>destructor</i> <a class="name" id="_tParser_l_r">~Parser</a>()  </div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mParser_m_tParser_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line46" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"> const&#160;<a href="Parser.html#ErrorList" >ErrorList</a>&amp; <a class="name" id="errors_l_rconst">errors</a>() <span class="keyword">const</span> </div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_merrors_l_rconst" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line48" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;unsigned&#160;long <span class="name"><a href="Parser.html#origin_lconst.char_S_cstd_mstring_A_rconst" >origin</a></span>(const&#160;char*, std::string&amp;) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line52" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Return the origin of the given pointer
(filename and line number)</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="PTree/Node.html" >PTree::Node</a>* <a class="name" id="parse_l_r">parse</a>()  </div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mparse_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line54" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Classes Summary:</div>
<div class="item"><div class="synopsis">class <a href="Parser/StatusGuard.html" >StatusGuard</a></div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mStatusGuard" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line68" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>A StatusGuard manages a tentative parse.</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Structs Summary:</div>
<div class="item"><div class="synopsis">struct <a class="name" id="ScopeGuard">ScopeGuard</a></div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line61" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Enums Summary:</div>
<div class="item"><div class="synopsis"><a class="name" id="DeclKind">DeclKind</a> kDeclarator, kArgDeclarator, kCastDeclarator</div> <div class="xref"><a href="../../XRef/xref18.html#Synopsis_mParser_mDeclKind" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line57" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="TemplateDeclKind">TemplateDeclKind</a> tdk_unknown, tdk_decl, tdk_instantiation, tdk_specialization, num_tdks</div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mTemplateDeclKind" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line58" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Member function templates Summary:</div>
<div class="item"><div class="synopsis"><div class="template">template &lt;<span class="keyword">typename</span> T&gt;</div> &#160;bool <a class="name" id="declare_lT_S_r">declare</a>(T*)  </div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mdeclare_lT_S_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line87" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="mark_error_l_r">mark_error</a>()  </div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmark_error_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line85" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="show_message_head_lconst.char_S_r">show_message_head</a>(const&#160;char*)  </div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mshow_message_head_lconst.char_S_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line88" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="definition_lPTree_mNode_S_A_r">definition</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line90" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="null_declaration_lPTree_mNode_S_A_r">null_declaration</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line91" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="typedef__lPTree_mTypedef_S_A_r">typedef_</a>(<a href="PTree/Typedef.html" >PTree::Typedef</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line92" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="type_specifier_lPTree_mNode_S_A_cbool_cPTree_mEncoding_A_r">type_specifier</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, bool, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line93" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="is_type_specifier_l_r">is_type_specifier</a>()  </div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mis_type_specifier_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line94" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="metaclass_decl_lPTree_mNode_S_A_r">metaclass_decl</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line95" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="meta_arguments_lPTree_mNode_S_A_r">meta_arguments</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line96" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="linkage_spec_lPTree_mNode_S_A_r">linkage_spec</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line97" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="namespace_spec_lPTree_mNamespaceSpec_S_A_r">namespace_spec</a>(<a href="PTree/NamespaceSpec.html" >PTree::NamespaceSpec</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line98" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="namespace_alias_lPTree_mNamespaceAlias_S_A_r">namespace_alias</a>(<a href="PTree/NamespaceAlias.html" >PTree::NamespaceAlias</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line99" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="using_directive_lPTree_mUsingDirective_S_A_r">using_directive</a>(<a href="PTree/UsingDirective.html" >PTree::UsingDirective</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line100" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="using_declaration_lPTree_mUsingDeclaration_S_A_r">using_declaration</a>(<a href="PTree/UsingDeclaration.html" >PTree::UsingDeclaration</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line101" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="linkage_body_lPTree_mNode_S_A_r">linkage_body</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line102" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="template_decl_lPTree_mNode_S_A_r">template_decl</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line103" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="template_decl2_lPTree_mTemplateDecl_S_A_cTemplateDeclKind_A_r">template_decl2</a>(<a href="PTree/TemplateDecl.html" >PTree::TemplateDecl</a>*&amp;, <a href="Parser.html#TemplateDeclKind" >TemplateDeclKind</a>&amp; <span class="variable">kind</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line104" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#template_parameter_list_lPTree_mList_S_A_r" >template_parameter_list</a></span>(<a href="PTree/List.html" >PTree::List</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line110" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>template-parameter-list:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#template_parameter_lPTree_mNode_S_A_r" >template_parameter</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line116" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>template-parameter:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#type_parameter_lPTree_mNode_S_A_r" >type_parameter</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line126" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>type-parameter:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#extern_template_decl_lPTree_mNode_S_A_r" >extern_template_decl</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line132" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>GNU extension:
extern-template-decl:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="declaration_lPTree_mDeclaration_S_A_r">declaration</a>(<a href="PTree/Declaration.html" >PTree::Declaration</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line134" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="integral_declaration_lPTree_mDeclaration_S_A_cPTree_mEncoding_A_cPTree_mNode_S_cPTree_mNode_S_cPTree_mNode_S_r">integral_declaration</a>(<a href="PTree/Declaration.html" >PTree::Declaration</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line135" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="const_declaration_lPTree_mDeclaration_S_A_cPTree_mEncoding_A_cPTree_mNode_S_cPTree_mNode_S_r">const_declaration</a>(<a href="PTree/Declaration.html" >PTree::Declaration</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line136" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="other_declaration_lPTree_mDeclaration_S_A_cPTree_mEncoding_A_cPTree_mNode_S_cPTree_mNode_S_cPTree_mNode_S_r">other_declaration</a>(<a href="PTree/Declaration.html" >PTree::Declaration</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line137" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#condition_lPTree_mNode_S_A_r" >condition</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line143" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>condition:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="is_constructor_decl_l_r">is_constructor_decl</a>()  </div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mis_constructor_decl_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line145" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="is_ptr_to_member_lint_r">is_ptr_to_member</a>(int)  </div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mis_ptr_to_member_lint_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line146" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="opt_member_spec_lPTree_mNode_S_A_r">opt_member_spec</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line147" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#opt_storage_spec_lPTree_mNode_S_A_r" >opt_storage_spec</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line157" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>storage-spec:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#opt_cv_qualifier_lPTree_mNode_S_A_r" >opt_cv_qualifier</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line164" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>cv-qualifier:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="opt_integral_type_or_class_spec_lPTree_mNode_S_A_cPTree_mEncoding_A_r">opt_integral_type_or_class_spec</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line165" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="constructor_decl_lPTree_mNode_S_A_cPTree_mEncoding_A_r">constructor_decl</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line166" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="opt_throw_decl_lPTree_mNode_S_A_r">opt_throw_decl</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line167" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#init_declarator_list_lPTree_mNode_S_A_cPTree_mEncoding_A_cbool_cbool_r" >init_declarator_list</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, bool, bool = <span class="value">false</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line170" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>[gram.dcl.decl]</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="init_declarator_lPTree_mNode_S_A_cPTree_mEncoding_A_cbool_cbool_r">init_declarator</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, bool, bool)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line171" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="declarator_lPTree_mNode_S_A_cDeclKind_cbool_cPTree_mEncoding_A_cPTree_mEncoding_A_cbool_cbool_r">declarator</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="Parser.html#DeclKind" >DeclKind</a>, bool, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, bool, bool = <span class="value">false</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line174" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="declarator2_lPTree_mNode_S_A_cDeclKind_cbool_cPTree_mEncoding_A_cPTree_mEncoding_A_cbool_cbool_cPTree_mNode_S_S_r">declarator2</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="Parser.html#DeclKind" >DeclKind</a>, bool, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, bool, bool, <a href="PTree/Node.html" >PTree::Node</a>**)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line177" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="opt_ptr_operator_lPTree_mNode_S_A_cPTree_mEncoding_A_r">opt_ptr_operator</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line178" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="member_initializers_lPTree_mNode_S_A_r">member_initializers</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line179" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="member_init_lPTree_mNode_S_A_r">member_init</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line180" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="name_lPTree_mNode_S_A_cPTree_mEncoding_A_r">name</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line182" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="operator_name_lPTree_mNode_S_A_cPTree_mEncoding_A_r">operator_name</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line183" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="cast_operator_name_lPTree_mNode_S_A_cPTree_mEncoding_A_r">cast_operator_name</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line184" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="ptr_to_member_lPTree_mNode_S_A_cPTree_mEncoding_A_r">ptr_to_member</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line185" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="template_args_lPTree_mNode_S_A_cPTree_mEncoding_A_r">template_args</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line186" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="parameter_declaration_list_or_init_lPTree_mNode_S_A_cbool_A_cPTree_mEncoding_A_cbool_r">parameter_declaration_list_or_init</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, bool&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, bool)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line189" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="parameter_declaration_list_lPTree_mNode_S_A_cPTree_mEncoding_A_r">parameter_declaration_list</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line190" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#parameter_declaration_lPTree_mParameterDeclaration_S_A_cPTree_mEncoding_A_r" >parameter_declaration</a></span>(<a href="PTree/ParameterDeclaration.html" >PTree::ParameterDeclaration</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line198" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>parameter-declaration:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="function_arguments_lPTree_mNode_S_A_r">function_arguments</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line200" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="designation_lPTree_mNode_S_A_r">designation</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line201" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="initialize_expr_lPTree_mNode_S_A_r">initialize_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line202" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="enum_spec_lPTree_mEnumSpec_S_A_cPTree_mEncoding_A_r">enum_spec</a>(<a href="PTree/EnumSpec.html" >PTree::EnumSpec</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line204" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="enum_body_lPTree_mNode_S_A_r">enum_body</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line205" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="class_spec_lPTree_mClassSpec_S_A_cPTree_mEncoding_A_r">class_spec</a>(<a href="PTree/ClassSpec.html" >PTree::ClassSpec</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line206" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#base_clause_lPTree_mNode_S_A_r" >base_clause</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line221" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>base-clause:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="class_body_lPTree_mClassBody_S_A_r">class_body</a>(<a href="PTree/ClassBody.html" >PTree::ClassBody</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line222" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="class_member_lPTree_mNode_S_A_r">class_member</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line223" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="access_decl_lPTree_mNode_S_A_r">access_decl</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line224" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="user_access_spec_lPTree_mNode_S_A_r">user_access_spec</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line225" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#expression_lPTree_mNode_S_A_r" >expression</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line231" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#assign_expr_lPTree_mNode_S_A_r" >assign_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line238" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>assignment-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#conditional_expr_lPTree_mNode_S_A_r" >conditional_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line244" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>conditional-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#logical_or_expr_lPTree_mNode_S_A_r" >logical_or_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line250" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>logical-or-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#logical_and_expr_lPTree_mNode_S_A_r" >logical_and_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line256" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>logical-and-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#inclusive_or_expr_lPTree_mNode_S_A_r" >inclusive_or_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line262" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>inclusive-or-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#exclusive_or_expr_lPTree_mNode_S_A_r" >exclusive_or_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line268" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>exclusive-or-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#and_expr_lPTree_mNode_S_A_r" >and_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line274" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>and-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#equality_expr_lPTree_mNode_S_A_r" >equality_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line281" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>equality-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#relational_expr_lPTree_mNode_S_A_r" >relational_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line290" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>relational-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#shift_expr_lPTree_mNode_S_A_r" >shift_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line297" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>shift-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#additive_expr_lPTree_mNode_S_A_r" >additive_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line304" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>additive-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#multiplicative_expr_lPTree_mNode_S_A_r" >multiplicative_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line312" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>multiplicative-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#pm_expr_lPTree_mNode_S_A_r" >pm_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line319" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>pm-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#cast_expr_lPTree_mNode_S_A_r" >cast_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line325" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>cast-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#type_id_lPTree_mNode_S_A_r" >type_id</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line330" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>type-id:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="type_id_lPTree_mNode_S_A_cPTree_mEncoding_A_r">type_id</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line331" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#unary_expr_lPTree_mNode_S_A_r" >unary_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line352" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>unary-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#throw_expr_lPTree_mNode_S_A_r" >throw_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line357" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>throw-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#sizeof_expr_lPTree_mNode_S_A_r" >sizeof_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line363" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>sizeof-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="offsetof_expr_lPTree_mNode_S_A_r">offsetof_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line365" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#typeid_expr_lPTree_mNode_S_A_r" >typeid_expr</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line371" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>typeid-expression:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="is_allocate_expr_lToken_mType_r">is_allocate_expr</a>(<a href="Token.html#Type" >Token::Type</a>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line372" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="allocate_expr_lPTree_mNode_S_A_r">allocate_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line373" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="userdef_keyword_lPTree_mNode_S_A_r">userdef_keyword</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line374" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="allocate_type_lPTree_mNode_S_A_r">allocate_type</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line375" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="new_declarator_lPTree_mDeclarator_S_A_cPTree_mEncoding_A_r">new_declarator</a>(<a href="PTree/Declarator.html" >PTree::Declarator</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line376" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="allocate_initializer_lPTree_mNode_S_A_r">allocate_initializer</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line377" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="postfix_expr_lPTree_mNode_S_A_r">postfix_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line378" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="primary_expr_lPTree_mNode_S_A_r">primary_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line379" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="typeof_expr_lPTree_mNode_S_A_r">typeof_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line380" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="userdef_statement_lPTree_mNode_S_A_r">userdef_statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line381" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="var_name_lPTree_mNode_S_A_r">var_name</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line382" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="var_name_core_lPTree_mNode_S_A_cPTree_mEncoding_A_r">var_name_core</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line383" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="is_template_args_l_r">is_template_args</a>()  </div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mis_template_args_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line384" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#function_body_lPTree_mBlock_S_A_r" >function_body</a></span>(<a href="PTree/Block.html" >PTree::Block</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line389" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>function-body:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#compound_statement_lPTree_mBlock_S_A_cbool_r" >compound_statement</a></span>(<a href="PTree/Block.html" >PTree::Block</a>*&amp;, bool <span class="variable">create_scope</span> = <span class="value">false</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line394" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>compound-statement:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="statement_lPTree_mNode_S_A_r">statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line395" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#if_statement_lPTree_mNode_S_A_r" >if_statement</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line401" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>if-statement:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#switch_statement_lPTree_mNode_S_A_r" >switch_statement</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line406" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>switch-statement:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#while_statement_lPTree_mNode_S_A_r" >while_statement</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line411" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>while-statement:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#do_statement_lPTree_mNode_S_A_r" >do_statement</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line416" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>do-statement:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="for_statement_lPTree_mNode_S_A_r">for_statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line417" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Parser.html#try_block_lPTree_mNode_S_A_r" >try_block</a></span>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line437" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>try-block:</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="expr_statement_lPTree_mNode_S_A_r">expr_statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line439" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="declaration_statement_lPTree_mDeclaration_S_A_r">declaration_statement</a>(<a href="PTree/Declaration.html" >PTree::Declaration</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line440" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="integral_decl_statement_lPTree_mDeclaration_S_A_cPTree_mEncoding_A_cPTree_mNode_S_cPTree_mNode_S_cPTree_mNode_S_r">integral_decl_statement</a>(<a href="PTree/Declaration.html" >PTree::Declaration</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line441" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="other_decl_statement_lPTree_mDeclaration_S_A_cPTree_mEncoding_A_cPTree_mNode_S_cPTree_mNode_S_r">other_decl_statement</a>(<a href="PTree/Declaration.html" >PTree::Declaration</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, <a href="PTree/Node.html" >PTree::Node</a>*, <a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line442" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="maybe_typename_or_class_template_lToken_A_r">maybe_typename_or_class_template</a>(<a href="Token.html" >Token</a>&amp;)  </div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmaybe_typename_or_class_template_lToken_A_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line444" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="skip_to_lToken_mType_r">skip_to</a>(<a href="Token.html#Type" >Token::Type</a> <span class="variable">token</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line445" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="more_var_name_l_r">more_var_name</a>()  </div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmore_var_name_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line448" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Data members Summary:</div>
<div class="item"><div class="synopsis"><a href="Lexer.html" >Lexer</a>&amp; <a class="name" id="my_lexer">my_lexer</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_lexer" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line450" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">int <a class="name" id="my_ruleset">my_ruleset</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_ruleset" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line451" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="SymbolFactory.html" >SymbolFactory</a>&amp; <a class="name" id="my_symbols">my_symbols</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_symbols" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line452" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">bool <span class="name"><a href="Parser.html#my_scope_is_valid" >my_scope_is_valid</a></span></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_scope_is_valid" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line457" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Record whether the current scope is valid.</p>
</div></div>
<div class="item"><div class="synopsis"><a href="Parser.html#ErrorList" >ErrorList</a> <a class="name" id="my_errors">my_errors</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_errors" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line458" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="PTree/Node.html" >PTree::Node</a>* <a class="name" id="my_comments">my_comments</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_comments" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line459" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">bool <span class="name"><a href="Parser.html#my_gt_is_operator" >my_gt_is_operator</a></span></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_gt_is_operator" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line462" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>If true, <em>&gt;</em> is interpreted as ther greater-than operator.</p>
</div></div>
<div class="item"><div class="synopsis">bool <a class="name" id="my_in_template_decl">my_in_template_decl</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_in_template_decl" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line463" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Enumerators Summary:</div>
<div class="item"><div class="synopsis"><a class="name" id="CXX">CXX</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="GCC">GCC</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="MSVC">MSVC</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="kDeclarator">kDeclarator</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="kArgDeclarator">kArgDeclarator</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="kCastDeclarator">kCastDeclarator</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="tdk_unknown">tdk_unknown</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="tdk_decl">tdk_decl</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="tdk_instantiation">tdk_instantiation</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="tdk_specialization">tdk_specialization</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="num_tdks">num_tdks</a></div> <div class="doc"></div></div>
</div><!-- summary -->
<!-- this part was generated by Inheritance -->
<!-- this part was generated by Detail -->
<div class="detail">
<div class="heading">Public Classes Details:</div>
<div class="item"><div class="synopsis">class <a href="Parser/Error.html" >Error</a></div> <div class="xref"><a href="../../XRef/xref18.html#Synopsis_mParser_mError" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line37" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Error is used to cache parse errors encountered during the execution
of the parse method.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Public Enums Details:</div>
<div class="item"><span class="keyword">enum</span> <a class="name" id="RuleSet">RuleSet</a><div class="enum"><div class="enumerator"><a class="name" id="CXX">CXX</a> = <span class="value">0x01</span></div><div class="enumerator"><a class="name" id="GCC">GCC</a> = <span class="value">0x02</span></div><div class="enumerator"><a class="name" id="MSVC">MSVC</a> = <span class="value">0x04</span></div></div> <div class="doc"><p>RuleSet defines non-standard optional rules that can be chosen at runtime.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Public Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;unsigned&#160;long <a class="name" id="origin_lconst.char_S_cstd_mstring_A_rconst">origin</a>(const&#160;char*, std::string&amp;) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line52" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Return the origin of the given pointer
(filename and line number)</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Classes Details:</div>
<div class="item"><div class="synopsis">class <a href="Parser/StatusGuard.html" >StatusGuard</a></div> <div class="xref"><a href="../../XRef/xref19.html#Synopsis_mParser_mStatusGuard" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line68" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>A StatusGuard manages a tentative parse.
All actions invoked after its instantiation
will be rolled back in the destructor unless
'commit' has been called before.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="template_parameter_list_lPTree_mList_S_A_r">template_parameter_list</a>(<a href="PTree/List.html" >PTree::List</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line110" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>template-parameter-list:</p>
<ul class="simple">
<li>template-parameter</li>
<li>template-parameter-list <em>,</em> template-parameter</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="template_parameter_lPTree_mNode_S_A_r">template_parameter</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line116" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>template-parameter:</p>
<ul class="simple">
<li>type-parameter</li>
<li>parameter-declaration</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="type_parameter_lPTree_mNode_S_A_r">type_parameter</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line126" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>type-parameter:</p>
<ul class="simple">
<li>class identifier [opt]</li>
<li>class identifier [opt] <em>=</em> type-id</li>
<li>typename identifier [opt]</li>
<li>typename identifier [opt] <em>=</em> type-id</li>
<li>template  <em>&lt;</em> template-parameter-list <em>&gt;</em> class identifier [opt]</li>
<li>template  <em>&lt;</em> template-parameter-list <em>&gt;</em> class identifier [opt] <em>=</em> id-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="extern_template_decl_lPTree_mNode_S_A_r">extern_template_decl</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line132" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>GNU extension:
extern-template-decl:</p>
<ul class="simple">
<li>extern template declaration</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="condition_lPTree_mNode_S_A_r">condition</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line143" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>condition:</p>
<ul class="simple">
<li>expression</li>
<li>type-specifier-seq declarator <em>=</em> assignment-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="opt_storage_spec_lPTree_mNode_S_A_r">opt_storage_spec</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line157" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>storage-spec:</p>
<ul class="simple">
<li>empty</li>
<li>static</li>
<li>extern</li>
<li>auto</li>
<li>register</li>
<li>mutable</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="opt_cv_qualifier_lPTree_mNode_S_A_r">opt_cv_qualifier</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line164" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>cv-qualifier:</p>
<ul class="simple">
<li>empty</li>
<li>const</li>
<li>volatile</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="init_declarator_list_lPTree_mNode_S_A_cPTree_mEncoding_A_cbool_cbool_r">init_declarator_list</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, bool, bool = <span class="value">false</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line170" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>[gram.dcl.decl]</p>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="parameter_declaration_lPTree_mParameterDeclaration_S_A_cPTree_mEncoding_A_r">parameter_declaration</a>(<a href="PTree/ParameterDeclaration.html" >PTree::ParameterDeclaration</a>*&amp;, <a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line198" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>parameter-declaration:</p>
<ul class="simple">
<li>decl-specifier-seq declarator</li>
<li>decl-specifier-seq declarator <em>=</em> assignment-expression</li>
<li>decl-specifier-seq abstract-declarator [opt]</li>
<li>decl-specifier-seq abstract-declarator [opt] <em>=</em> assignment-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="base_clause_lPTree_mNode_S_A_r">base_clause</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line221" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>base-clause:</p>
<ul class="simple">
<li><em>:</em> base-specifier-list</li>
</ul>
<p>base-specifier-list:</p>
<ul class="simple">
<li>base-specifier</li>
<li>base-specifier-list <em>,</em> base-specifier</li>
</ul>
<p>base-specifier:</p>
<ul class="simple">
<li>virtual access-specifier [opt] <em>::</em> [opt] nested-name-specifier [opt] class-name</li>
<li>access-specifier virtual [opt] <em>::</em> [opt] nested-name-specifier [opt] class-name</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="expression_lPTree_mNode_S_A_r">expression</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line231" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>expression:</p>
<ul class="simple">
<li>assignment-expression</li>
<li>expression <em>,</em> assignment-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="assign_expr_lPTree_mNode_S_A_r">assign_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line238" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>assignment-expression:</p>
<ul class="simple">
<li>conditional-expression</li>
<li>logical-or-expression assignment-operator assignment-expression</li>
<li>throw-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="conditional_expr_lPTree_mNode_S_A_r">conditional_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line244" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>conditional-expression:</p>
<ul class="simple">
<li>logical-or-expression</li>
<li>logical-or-expression <em>?</em> expression <em>:</em> assignment-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="logical_or_expr_lPTree_mNode_S_A_r">logical_or_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line250" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>logical-or-expression:</p>
<ul class="simple">
<li>logical-and-expression</li>
<li>logical-or-expression <em>||</em> logical-and-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="logical_and_expr_lPTree_mNode_S_A_r">logical_and_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line256" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>logical-and-expression:</p>
<ul class="simple">
<li>inclusive-or-expression</li>
<li>logical-and-expr <em>&amp;&amp;</em> inclusive-or-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="inclusive_or_expr_lPTree_mNode_S_A_r">inclusive_or_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line262" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>inclusive-or-expression:</p>
<ul class="simple">
<li>exclusive-or-expression</li>
<li>inclusive-or-expression <em>|</em> exclusive-or-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="exclusive_or_expr_lPTree_mNode_S_A_r">exclusive_or_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line268" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>exclusive-or-expression:</p>
<ul class="simple">
<li>and-expression</li>
<li>exclusive-or-expression <em>^</em> and-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="and_expr_lPTree_mNode_S_A_r">and_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line274" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>and-expression:</p>
<ul class="simple">
<li>equality-expression</li>
<li>and-expression <em>&amp;</em> equality-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="equality_expr_lPTree_mNode_S_A_r">equality_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line281" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>equality-expression:</p>
<ul class="simple">
<li>relational-expression</li>
<li>equality-expression <em>==</em> relational-expression</li>
<li>equality-expression <em>!=</em> relational-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="relational_expr_lPTree_mNode_S_A_r">relational_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line290" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>relational-expression:</p>
<ul class="simple">
<li>shift-expression</li>
<li>relational-expression <em>&lt;</em> shift-expression</li>
<li>relational-expression <em>&gt;</em> shift-expression</li>
<li>relational-expression <em>&lt;=</em> shift-expression</li>
<li>relational-expression <em>&gt;=</em> shift-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="shift_expr_lPTree_mNode_S_A_r">shift_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line297" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>shift-expression:</p>
<ul class="simple">
<li>additive-expression</li>
<li>shift-expression <em>&lt;&lt;</em> additive-expression</li>
<li>shift-expression <em>&gt;&gt;</em> additive-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="additive_expr_lPTree_mNode_S_A_r">additive_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line304" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>additive-expression:</p>
<ul class="simple">
<li>multiplicative-expression</li>
<li>additive-expression <em>+</em> multiplicative-expression</li>
<li>additive-expression <em>-</em> multiplicative-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="multiplicative_expr_lPTree_mNode_S_A_r">multiplicative_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line312" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>multiplicative-expression:</p>
<ul class="simple">
<li>pm-expression</li>
<li>multiplicative-expression <em>*</em> pm-expression</li>
<li>multiplicative-expression <em>/</em> pm-expression</li>
<li>multiplicative-expression <em>%</em> pm-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="pm_expr_lPTree_mNode_S_A_r">pm_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line319" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>pm-expression:</p>
<ul class="simple">
<li>cast-expression</li>
<li>pm-expression <em>.*</em> cast-expression</li>
<li>pm-expression <em>-&gt;*</em> cast-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="cast_expr_lPTree_mNode_S_A_r">cast_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line325" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>cast-expression:</p>
<ul class="simple">
<li>unary-expression</li>
<li><em>(</em> type-id <em>)</em> cast-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="type_id_lPTree_mNode_S_A_r">type_id</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line330" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>type-id:</p>
<ul class="simple">
<li>type-specifier-seq abstract-declarator [opt]</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="unary_expr_lPTree_mNode_S_A_r">unary_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line352" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>unary-expression:</p>
<ul class="simple">
<li>postfix-expression</li>
<li><em>++</em> cast-expression</li>
<li><em>--</em> cast-expression</li>
<li>unary-operator cast-expression</li>
<li><em>sizeof</em> unary-expression</li>
<li><em>sizeof</em> <em>(</em> unary-expression <em>)</em></li>
<li>new-expression</li>
<li>delete-expression</li>
</ul>
<p>unary-operator:</p>
<ul class="simple">
<li><em>*</em></li>
<li><em>&amp;</em></li>
<li><em>+</em></li>
<li><em>-</em></li>
<li><em>!</em></li>
<li><em>~</em></li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="throw_expr_lPTree_mNode_S_A_r">throw_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line357" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>throw-expression:</p>
<ul class="simple">
<li><em>throw</em> assignment-expression</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="sizeof_expr_lPTree_mNode_S_A_r">sizeof_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line363" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>sizeof-expression:</p>
<ul class="simple">
<li><em>sizeof</em> unary-expression</li>
<li><em>sizeof</em> <em>(</em> type-id <em>)</em></li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="typeid_expr_lPTree_mNode_S_A_r">typeid_expr</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line371" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>typeid-expression:</p>
<ul class="simple">
<li>typeid <em>(</em> type-id <em>)</em></li>
<li>typeid <em>(</em> expression <em>)</em></li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="function_body_lPTree_mBlock_S_A_r">function_body</a>(<a href="PTree/Block.html" >PTree::Block</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line389" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>function-body:</p>
<ul class="simple">
<li>compound-statement</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="compound_statement_lPTree_mBlock_S_A_cbool_r">compound_statement</a>(<a href="PTree/Block.html" >PTree::Block</a>*&amp;, bool <span class="variable">create_scope</span> = <span class="value">false</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line394" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>compound-statement:</p>
<ul class="simple">
<li><em>{</em> statement [opt] <em>}</em></li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="if_statement_lPTree_mNode_S_A_r">if_statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line401" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>if-statement:</p>
<ul class="simple">
<li><em>if</em> <em>(</em> condition <em>)</em> statement</li>
<li><em>if</em> <em>(</em> condition <em>)</em> statement else statement</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="switch_statement_lPTree_mNode_S_A_r">switch_statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line406" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>switch-statement:</p>
<ul class="simple">
<li><em>switch</em> <em>(</em> condition <em>)</em> statement</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="while_statement_lPTree_mNode_S_A_r">while_statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line411" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>while-statement:</p>
<ul class="simple">
<li><em>while</em> <em>(</em> condition <em>)</em> statement</li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="do_statement_lPTree_mNode_S_A_r">do_statement</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line416" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>do-statement:</p>
<ul class="simple">
<li><em>do</em> statement <em>while</em> <em>(</em> condition <em>)</em> <em>;</em></li>
</ul>
</div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="try_block_lPTree_mNode_S_A_r">try_block</a>(<a href="PTree/Node.html" >PTree::Node</a>*&amp;)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line437" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>try-block:</p>
<ul class="simple">
<li><em>try</em> compound-statement handler-seq</li>
</ul>
<p>handler-seq:</p>
<ul class="simple">
<li>handler handler-seq [opt]</li>
</ul>
<p>handler:</p>
<ul class="simple">
<li><em>catch</em> <em>(</em> exception-declaration <em>)</em> compound-statement</li>
</ul>
<p>exception-declaration:</p>
<ul class="simple">
<li>type-specifier-seq declarator</li>
<li>type-specifier-seq abstract-declarator</li>
<li>type-specifier-seq</li>
<li><em>...</em></li>
</ul>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Data members Details:</div>
<div class="item"><div class="synopsis">bool <a class="name" id="my_scope_is_valid">my_scope_is_valid</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_scope_is_valid" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line457" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Record whether the current scope is valid.
This allows the parser to continue parsing even after
it was unable to enter a scope (such as in a function definition
with a qualified name that wasn't declared before).</p>
</div></div>
<div class="item"><div class="synopsis">bool <a class="name" id="my_gt_is_operator">my_gt_is_operator</a></div> <div class="xref"><a href="../../XRef/xref20.html#Synopsis_mParser_mmy_gt_is_operator" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Parser.hh.html#line462" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>If true, <em>&gt;</em> is interpreted as ther greater-than operator.
If false, it marks the end of a template-id or template-parameter-list.</p>
</div></div>
</div><!-- detail -->

<div class="logo">Generated on Thu Apr 16 16:27:41 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
